//#line 2 "/opt/ros/electric/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"
// *********************************************************
// 
// File autogenerated for the art_common package 
// by the dynamic_reconfigure package.
// Please do not edit.
// 
// ********************************************************/

/***********************************************************
 * Software License Agreement (BSD License)
 *
 *  Copyright (c) 2008, Willow Garage, Inc.
 *  All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *   * Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *   * Redistributions in binary form must reproduce the above
 *     copyright notice, this list of conditions and the following
 *     disclaimer in the documentation and/or other materials provided
 *     with the distribution.
 *   * Neither the name of the Willow Garage nor the names of its
 *     contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 *  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 *  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 *  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 *  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 *  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 *  ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 *  POSSIBILITY OF SUCH DAMAGE.
 ***********************************************************/

// Author: Blaise Gassend


#ifndef __art_common__CAMERATRANSFORMCONFIG_H__
#define __art_common__CAMERATRANSFORMCONFIG_H__

#include <dynamic_reconfigure/config_tools.h>
#include <limits>
#include <ros/node_handle.h>
#include <dynamic_reconfigure/ConfigDescription.h>
#include <dynamic_reconfigure/ParamDescription.h>
#include <dynamic_reconfigure/config_init_mutex.h>

namespace art_common
{
  class CameraTransformConfigStatics;
  
  class CameraTransformConfig
  {
  public:
    class AbstractParamDescription : public dynamic_reconfigure::ParamDescription
    {
    public:
      AbstractParamDescription(std::string n, std::string t, uint32_t l, 
          std::string d, std::string e)
      {
        name = n;
        type = t;
        level = l;
        description = d;
        edit_method = e;
      }
      
      virtual void clamp(CameraTransformConfig &config, const CameraTransformConfig &max, const CameraTransformConfig &min) const = 0;
      virtual void calcLevel(uint32_t &level, const CameraTransformConfig &config1, const CameraTransformConfig &config2) const = 0;
      virtual void fromServer(const ros::NodeHandle &nh, CameraTransformConfig &config) const = 0;
      virtual void toServer(const ros::NodeHandle &nh, const CameraTransformConfig &config) const = 0;
      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, CameraTransformConfig &config) const = 0;
      virtual void toMessage(dynamic_reconfigure::Config &msg, const CameraTransformConfig &config) const = 0;
    };

    typedef boost::shared_ptr<AbstractParamDescription> AbstractParamDescriptionPtr;
    typedef boost::shared_ptr<const AbstractParamDescription> AbstractParamDescriptionConstPtr;
    
    template <class T>
    class ParamDescription : public AbstractParamDescription
    {
    public:
      ParamDescription(std::string name, std::string type, uint32_t level, 
          std::string description, std::string edit_method, T CameraTransformConfig::* f) :
        AbstractParamDescription(name, type, level, description, edit_method),
        field(f)
      {}

      T (CameraTransformConfig::* field);

      virtual void clamp(CameraTransformConfig &config, const CameraTransformConfig &max, const CameraTransformConfig &min) const
      {
        if (config.*field > max.*field)
          config.*field = max.*field;
        
        if (config.*field < min.*field)
          config.*field = min.*field;
      }

      virtual void calcLevel(uint32_t &comb_level, const CameraTransformConfig &config1, const CameraTransformConfig &config2) const
      {
        if (config1.*field != config2.*field)
          comb_level |= level;
      }

      virtual void fromServer(const ros::NodeHandle &nh, CameraTransformConfig &config) const
      {
        nh.getParam(name, config.*field);
      }

      virtual void toServer(const ros::NodeHandle &nh, const CameraTransformConfig &config) const
      {
        nh.setParam(name, config.*field);
      }

      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, CameraTransformConfig &config) const
      {
        return dynamic_reconfigure::ConfigTools::getParameter(msg, name, config.*field);
      }

      virtual void toMessage(dynamic_reconfigure::Config &msg, const CameraTransformConfig &config) const
      {
        dynamic_reconfigure::ConfigTools::appendParameter(msg, name, config.*field);
      }
    };

//#line 52 "../cfg/CameraTransform.cfg"
      double left_front_camera_px;
//#line 56 "../cfg/CameraTransform.cfg"
      double left_front_camera_py;
//#line 60 "../cfg/CameraTransform.cfg"
      double left_front_camera_pz;
//#line 64 "../cfg/CameraTransform.cfg"
      double left_front_camera_roll;
//#line 68 "../cfg/CameraTransform.cfg"
      double left_front_camera_pitch;
//#line 72 "../cfg/CameraTransform.cfg"
      double left_front_camera_yaw;
//#line 77 "../cfg/CameraTransform.cfg"
      double center_front_camera_px;
//#line 81 "../cfg/CameraTransform.cfg"
      double center_front_camera_py;
//#line 85 "../cfg/CameraTransform.cfg"
      double center_front_camera_pz;
//#line 89 "../cfg/CameraTransform.cfg"
      double center_front_camera_roll;
//#line 93 "../cfg/CameraTransform.cfg"
      double center_front_camera_pitch;
//#line 97 "../cfg/CameraTransform.cfg"
      double center_front_camera_yaw;
//#line 102 "../cfg/CameraTransform.cfg"
      double right_front_camera_px;
//#line 106 "../cfg/CameraTransform.cfg"
      double right_front_camera_py;
//#line 110 "../cfg/CameraTransform.cfg"
      double right_front_camera_pz;
//#line 114 "../cfg/CameraTransform.cfg"
      double right_front_camera_roll;
//#line 118 "../cfg/CameraTransform.cfg"
      double right_front_camera_pitch;
//#line 122 "../cfg/CameraTransform.cfg"
      double right_front_camera_yaw;
//#line 127 "../cfg/CameraTransform.cfg"
      double velodyne_px;
//#line 131 "../cfg/CameraTransform.cfg"
      double velodyne_py;
//#line 135 "../cfg/CameraTransform.cfg"
      double velodyne_pz;
//#line 139 "../cfg/CameraTransform.cfg"
      double velodyne_roll;
//#line 143 "../cfg/CameraTransform.cfg"
      double velodyne_pitch;
//#line 147 "../cfg/CameraTransform.cfg"
      double velodyne_yaw;
//#line 138 "/opt/ros/electric/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"

    bool __fromMessage__(dynamic_reconfigure::Config &msg)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      int count = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        if ((*i)->fromMessage(msg, *this))
          count++;
      if (count != dynamic_reconfigure::ConfigTools::size(msg))
      {
        ROS_ERROR("CameraTransformConfig::__fromMessage__ called with an unexpected parameter.");
        ROS_ERROR("Booleans:");
        for (unsigned int i = 0; i < msg.bools.size(); i++)
          ROS_ERROR("  %s", msg.bools[i].name.c_str());
        ROS_ERROR("Integers:");
        for (unsigned int i = 0; i < msg.ints.size(); i++)
          ROS_ERROR("  %s", msg.ints[i].name.c_str());
        ROS_ERROR("Doubles:");
        for (unsigned int i = 0; i < msg.doubles.size(); i++)
          ROS_ERROR("  %s", msg.doubles[i].name.c_str());
        ROS_ERROR("Strings:");
        for (unsigned int i = 0; i < msg.strs.size(); i++)
          ROS_ERROR("  %s", msg.strs[i].name.c_str());
        // @todo Check that there are no duplicates. Make this error more
        // explicit.
        return false;
      }
      return true;
    }

    // This version of __toMessage__ is used during initialization of
    // statics when __getParamDescriptions__ can't be called yet.
    void __toMessage__(dynamic_reconfigure::Config &msg, const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__) const
    {
      dynamic_reconfigure::ConfigTools::clear(msg);
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->toMessage(msg, *this);
    }
    
    void __toMessage__(dynamic_reconfigure::Config &msg) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      __toMessage__(msg, __param_descriptions__);
    }
    
    void __toServer__(const ros::NodeHandle &nh) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->toServer(nh, *this);
    }

    void __fromServer__(const ros::NodeHandle &nh)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->fromServer(nh, *this);
    }

    void __clamp__()
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const CameraTransformConfig &__max__ = __getMax__();
      const CameraTransformConfig &__min__ = __getMin__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->clamp(*this, __max__, __min__);
    }

    uint32_t __level__(const CameraTransformConfig &config) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      uint32_t level = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->calcLevel(level, config, *this);
      return level;
    }
    
    static const dynamic_reconfigure::ConfigDescription &__getDescriptionMessage__();
    static const CameraTransformConfig &__getDefault__();
    static const CameraTransformConfig &__getMax__();
    static const CameraTransformConfig &__getMin__();
    static const std::vector<AbstractParamDescriptionConstPtr> &__getParamDescriptions__();
    
  private:
    static const CameraTransformConfigStatics *__get_statics__();
  };
  
  template <> // Max and min are ignored for strings.
  inline void CameraTransformConfig::ParamDescription<std::string>::clamp(CameraTransformConfig &config, const CameraTransformConfig &max, const CameraTransformConfig &min) const
  {
    return;
  }

  class CameraTransformConfigStatics
  {
    friend class CameraTransformConfig;
    
    CameraTransformConfigStatics()
    {
//#line 52 "../cfg/CameraTransform.cfg"
      __min__.left_front_camera_px = -3.0;
//#line 52 "../cfg/CameraTransform.cfg"
      __max__.left_front_camera_px = 3.0;
//#line 52 "../cfg/CameraTransform.cfg"
      __default__.left_front_camera_px = 0.471;
//#line 52 "../cfg/CameraTransform.cfg"
      __param_descriptions__.push_back(CameraTransformConfig::AbstractParamDescriptionConstPtr(new CameraTransformConfig::ParamDescription<double>("left_front_camera_px", "double", 0, "left front camera position x", "", &CameraTransformConfig::left_front_camera_px)));
//#line 56 "../cfg/CameraTransform.cfg"
      __min__.left_front_camera_py = -3.0;
//#line 56 "../cfg/CameraTransform.cfg"
      __max__.left_front_camera_py = 3.0;
//#line 56 "../cfg/CameraTransform.cfg"
      __default__.left_front_camera_py = 0.412;
//#line 56 "../cfg/CameraTransform.cfg"
      __param_descriptions__.push_back(CameraTransformConfig::AbstractParamDescriptionConstPtr(new CameraTransformConfig::ParamDescription<double>("left_front_camera_py", "double", 0, "left front camera position y", "", &CameraTransformConfig::left_front_camera_py)));
//#line 60 "../cfg/CameraTransform.cfg"
      __min__.left_front_camera_pz = -3.0;
//#line 60 "../cfg/CameraTransform.cfg"
      __max__.left_front_camera_pz = 3.0;
//#line 60 "../cfg/CameraTransform.cfg"
      __default__.left_front_camera_pz = 2.184;
//#line 60 "../cfg/CameraTransform.cfg"
      __param_descriptions__.push_back(CameraTransformConfig::AbstractParamDescriptionConstPtr(new CameraTransformConfig::ParamDescription<double>("left_front_camera_pz", "double", 0, "left front camera position z", "", &CameraTransformConfig::left_front_camera_pz)));
//#line 64 "../cfg/CameraTransform.cfg"
      __min__.left_front_camera_roll = -3.14159265359;
//#line 64 "../cfg/CameraTransform.cfg"
      __max__.left_front_camera_roll = 3.14159265359;
//#line 64 "../cfg/CameraTransform.cfg"
      __default__.left_front_camera_roll = 0.0;
//#line 64 "../cfg/CameraTransform.cfg"
      __param_descriptions__.push_back(CameraTransformConfig::AbstractParamDescriptionConstPtr(new CameraTransformConfig::ParamDescription<double>("left_front_camera_roll", "double", 0, "left front camera roll", "", &CameraTransformConfig::left_front_camera_roll)));
//#line 68 "../cfg/CameraTransform.cfg"
      __min__.left_front_camera_pitch = -3.14159265359;
//#line 68 "../cfg/CameraTransform.cfg"
      __max__.left_front_camera_pitch = 3.14159265359;
//#line 68 "../cfg/CameraTransform.cfg"
      __default__.left_front_camera_pitch = -0.017;
//#line 68 "../cfg/CameraTransform.cfg"
      __param_descriptions__.push_back(CameraTransformConfig::AbstractParamDescriptionConstPtr(new CameraTransformConfig::ParamDescription<double>("left_front_camera_pitch", "double", 0, "left front camera pitch", "", &CameraTransformConfig::left_front_camera_pitch)));
//#line 72 "../cfg/CameraTransform.cfg"
      __min__.left_front_camera_yaw = -3.14159265359;
//#line 72 "../cfg/CameraTransform.cfg"
      __max__.left_front_camera_yaw = 3.14159265359;
//#line 72 "../cfg/CameraTransform.cfg"
      __default__.left_front_camera_yaw = 0.97;
//#line 72 "../cfg/CameraTransform.cfg"
      __param_descriptions__.push_back(CameraTransformConfig::AbstractParamDescriptionConstPtr(new CameraTransformConfig::ParamDescription<double>("left_front_camera_yaw", "double", 0, "left front camera yaw", "", &CameraTransformConfig::left_front_camera_yaw)));
//#line 77 "../cfg/CameraTransform.cfg"
      __min__.center_front_camera_px = -3.0;
//#line 77 "../cfg/CameraTransform.cfg"
      __max__.center_front_camera_px = 3.0;
//#line 77 "../cfg/CameraTransform.cfg"
      __default__.center_front_camera_px = 0.548;
//#line 77 "../cfg/CameraTransform.cfg"
      __param_descriptions__.push_back(CameraTransformConfig::AbstractParamDescriptionConstPtr(new CameraTransformConfig::ParamDescription<double>("center_front_camera_px", "double", 0, "center front camera position x", "", &CameraTransformConfig::center_front_camera_px)));
//#line 81 "../cfg/CameraTransform.cfg"
      __min__.center_front_camera_py = -3.0;
//#line 81 "../cfg/CameraTransform.cfg"
      __max__.center_front_camera_py = 3.0;
//#line 81 "../cfg/CameraTransform.cfg"
      __default__.center_front_camera_py = 0.278;
//#line 81 "../cfg/CameraTransform.cfg"
      __param_descriptions__.push_back(CameraTransformConfig::AbstractParamDescriptionConstPtr(new CameraTransformConfig::ParamDescription<double>("center_front_camera_py", "double", 0, "center front camera position y", "", &CameraTransformConfig::center_front_camera_py)));
//#line 85 "../cfg/CameraTransform.cfg"
      __min__.center_front_camera_pz = -3.0;
//#line 85 "../cfg/CameraTransform.cfg"
      __max__.center_front_camera_pz = 3.0;
//#line 85 "../cfg/CameraTransform.cfg"
      __default__.center_front_camera_pz = 2.184;
//#line 85 "../cfg/CameraTransform.cfg"
      __param_descriptions__.push_back(CameraTransformConfig::AbstractParamDescriptionConstPtr(new CameraTransformConfig::ParamDescription<double>("center_front_camera_pz", "double", 0, "center front camera position z", "", &CameraTransformConfig::center_front_camera_pz)));
//#line 89 "../cfg/CameraTransform.cfg"
      __min__.center_front_camera_roll = -3.14159265359;
//#line 89 "../cfg/CameraTransform.cfg"
      __max__.center_front_camera_roll = 3.14159265359;
//#line 89 "../cfg/CameraTransform.cfg"
      __default__.center_front_camera_roll = 0.0;
//#line 89 "../cfg/CameraTransform.cfg"
      __param_descriptions__.push_back(CameraTransformConfig::AbstractParamDescriptionConstPtr(new CameraTransformConfig::ParamDescription<double>("center_front_camera_roll", "double", 0, "center front camera roll", "", &CameraTransformConfig::center_front_camera_roll)));
//#line 93 "../cfg/CameraTransform.cfg"
      __min__.center_front_camera_pitch = -3.14159265359;
//#line 93 "../cfg/CameraTransform.cfg"
      __max__.center_front_camera_pitch = 3.14159265359;
//#line 93 "../cfg/CameraTransform.cfg"
      __default__.center_front_camera_pitch = 0.025;
//#line 93 "../cfg/CameraTransform.cfg"
      __param_descriptions__.push_back(CameraTransformConfig::AbstractParamDescriptionConstPtr(new CameraTransformConfig::ParamDescription<double>("center_front_camera_pitch", "double", 0, "center front camera pitch", "", &CameraTransformConfig::center_front_camera_pitch)));
//#line 97 "../cfg/CameraTransform.cfg"
      __min__.center_front_camera_yaw = -3.14159265359;
//#line 97 "../cfg/CameraTransform.cfg"
      __max__.center_front_camera_yaw = 3.14159265359;
//#line 97 "../cfg/CameraTransform.cfg"
      __default__.center_front_camera_yaw = -0.052;
//#line 97 "../cfg/CameraTransform.cfg"
      __param_descriptions__.push_back(CameraTransformConfig::AbstractParamDescriptionConstPtr(new CameraTransformConfig::ParamDescription<double>("center_front_camera_yaw", "double", 0, "center front camera yaw", "", &CameraTransformConfig::center_front_camera_yaw)));
//#line 102 "../cfg/CameraTransform.cfg"
      __min__.right_front_camera_px = -3.0;
//#line 102 "../cfg/CameraTransform.cfg"
      __max__.right_front_camera_px = 3.0;
//#line 102 "../cfg/CameraTransform.cfg"
      __default__.right_front_camera_px = 0.471;
//#line 102 "../cfg/CameraTransform.cfg"
      __param_descriptions__.push_back(CameraTransformConfig::AbstractParamDescriptionConstPtr(new CameraTransformConfig::ParamDescription<double>("right_front_camera_px", "double", 0, "right front camera position x", "", &CameraTransformConfig::right_front_camera_px)));
//#line 106 "../cfg/CameraTransform.cfg"
      __min__.right_front_camera_py = -3.0;
//#line 106 "../cfg/CameraTransform.cfg"
      __max__.right_front_camera_py = 3.0;
//#line 106 "../cfg/CameraTransform.cfg"
      __default__.right_front_camera_py = 0.144;
//#line 106 "../cfg/CameraTransform.cfg"
      __param_descriptions__.push_back(CameraTransformConfig::AbstractParamDescriptionConstPtr(new CameraTransformConfig::ParamDescription<double>("right_front_camera_py", "double", 0, "right front camera position y", "", &CameraTransformConfig::right_front_camera_py)));
//#line 110 "../cfg/CameraTransform.cfg"
      __min__.right_front_camera_pz = -3.0;
//#line 110 "../cfg/CameraTransform.cfg"
      __max__.right_front_camera_pz = 3.0;
//#line 110 "../cfg/CameraTransform.cfg"
      __default__.right_front_camera_pz = 2.184;
//#line 110 "../cfg/CameraTransform.cfg"
      __param_descriptions__.push_back(CameraTransformConfig::AbstractParamDescriptionConstPtr(new CameraTransformConfig::ParamDescription<double>("right_front_camera_pz", "double", 0, "right front camera position z", "", &CameraTransformConfig::right_front_camera_pz)));
//#line 114 "../cfg/CameraTransform.cfg"
      __min__.right_front_camera_roll = -3.14159265359;
//#line 114 "../cfg/CameraTransform.cfg"
      __max__.right_front_camera_roll = 3.14159265359;
//#line 114 "../cfg/CameraTransform.cfg"
      __default__.right_front_camera_roll = 0.0;
//#line 114 "../cfg/CameraTransform.cfg"
      __param_descriptions__.push_back(CameraTransformConfig::AbstractParamDescriptionConstPtr(new CameraTransformConfig::ParamDescription<double>("right_front_camera_roll", "double", 0, "right front camera roll", "", &CameraTransformConfig::right_front_camera_roll)));
//#line 118 "../cfg/CameraTransform.cfg"
      __min__.right_front_camera_pitch = -3.14159265359;
//#line 118 "../cfg/CameraTransform.cfg"
      __max__.right_front_camera_pitch = 3.14159265359;
//#line 118 "../cfg/CameraTransform.cfg"
      __default__.right_front_camera_pitch = 0.022;
//#line 118 "../cfg/CameraTransform.cfg"
      __param_descriptions__.push_back(CameraTransformConfig::AbstractParamDescriptionConstPtr(new CameraTransformConfig::ParamDescription<double>("right_front_camera_pitch", "double", 0, "right front camera pitch", "", &CameraTransformConfig::right_front_camera_pitch)));
//#line 122 "../cfg/CameraTransform.cfg"
      __min__.right_front_camera_yaw = -3.14159265359;
//#line 122 "../cfg/CameraTransform.cfg"
      __max__.right_front_camera_yaw = 3.14159265359;
//#line 122 "../cfg/CameraTransform.cfg"
      __default__.right_front_camera_yaw = -1.035;
//#line 122 "../cfg/CameraTransform.cfg"
      __param_descriptions__.push_back(CameraTransformConfig::AbstractParamDescriptionConstPtr(new CameraTransformConfig::ParamDescription<double>("right_front_camera_yaw", "double", 0, "right front camera yaw", "", &CameraTransformConfig::right_front_camera_yaw)));
//#line 127 "../cfg/CameraTransform.cfg"
      __min__.velodyne_px = -3.0;
//#line 127 "../cfg/CameraTransform.cfg"
      __max__.velodyne_px = 3.0;
//#line 127 "../cfg/CameraTransform.cfg"
      __default__.velodyne_px = 0.393;
//#line 127 "../cfg/CameraTransform.cfg"
      __param_descriptions__.push_back(CameraTransformConfig::AbstractParamDescriptionConstPtr(new CameraTransformConfig::ParamDescription<double>("velodyne_px", "double", 0, "velodyne position x", "", &CameraTransformConfig::velodyne_px)));
//#line 131 "../cfg/CameraTransform.cfg"
      __min__.velodyne_py = -3.0;
//#line 131 "../cfg/CameraTransform.cfg"
      __max__.velodyne_py = 3.0;
//#line 131 "../cfg/CameraTransform.cfg"
      __default__.velodyne_py = 0.278;
//#line 131 "../cfg/CameraTransform.cfg"
      __param_descriptions__.push_back(CameraTransformConfig::AbstractParamDescriptionConstPtr(new CameraTransformConfig::ParamDescription<double>("velodyne_py", "double", 0, "velodyne position y", "", &CameraTransformConfig::velodyne_py)));
//#line 135 "../cfg/CameraTransform.cfg"
      __min__.velodyne_pz = -3.0;
//#line 135 "../cfg/CameraTransform.cfg"
      __max__.velodyne_pz = 3.0;
//#line 135 "../cfg/CameraTransform.cfg"
      __default__.velodyne_pz = 2.4;
//#line 135 "../cfg/CameraTransform.cfg"
      __param_descriptions__.push_back(CameraTransformConfig::AbstractParamDescriptionConstPtr(new CameraTransformConfig::ParamDescription<double>("velodyne_pz", "double", 0, "velodyne position z", "", &CameraTransformConfig::velodyne_pz)));
//#line 139 "../cfg/CameraTransform.cfg"
      __min__.velodyne_roll = -3.14159265359;
//#line 139 "../cfg/CameraTransform.cfg"
      __max__.velodyne_roll = 3.14159265359;
//#line 139 "../cfg/CameraTransform.cfg"
      __default__.velodyne_roll = 0.0062133721371;
//#line 139 "../cfg/CameraTransform.cfg"
      __param_descriptions__.push_back(CameraTransformConfig::AbstractParamDescriptionConstPtr(new CameraTransformConfig::ParamDescription<double>("velodyne_roll", "double", 0, "velodyne roll", "", &CameraTransformConfig::velodyne_roll)));
//#line 143 "../cfg/CameraTransform.cfg"
      __min__.velodyne_pitch = -3.14159265359;
//#line 143 "../cfg/CameraTransform.cfg"
      __max__.velodyne_pitch = 3.14159265359;
//#line 143 "../cfg/CameraTransform.cfg"
      __default__.velodyne_pitch = 0.0163537350912;
//#line 143 "../cfg/CameraTransform.cfg"
      __param_descriptions__.push_back(CameraTransformConfig::AbstractParamDescriptionConstPtr(new CameraTransformConfig::ParamDescription<double>("velodyne_pitch", "double", 0, "velodyne pitch", "", &CameraTransformConfig::velodyne_pitch)));
//#line 147 "../cfg/CameraTransform.cfg"
      __min__.velodyne_yaw = -3.14159265359;
//#line 147 "../cfg/CameraTransform.cfg"
      __max__.velodyne_yaw = 3.14159265359;
//#line 147 "../cfg/CameraTransform.cfg"
      __default__.velodyne_yaw = -0.02155;
//#line 147 "../cfg/CameraTransform.cfg"
      __param_descriptions__.push_back(CameraTransformConfig::AbstractParamDescriptionConstPtr(new CameraTransformConfig::ParamDescription<double>("velodyne_yaw", "double", 0, "velodyne yaw", "", &CameraTransformConfig::velodyne_yaw)));
//#line 239 "/opt/ros/electric/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"
    
      for (std::vector<CameraTransformConfig::AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        __description_message__.parameters.push_back(**i);
      __max__.__toMessage__(__description_message__.max, __param_descriptions__); 
      __min__.__toMessage__(__description_message__.min, __param_descriptions__); 
      __default__.__toMessage__(__description_message__.dflt, __param_descriptions__); 
    }
    std::vector<CameraTransformConfig::AbstractParamDescriptionConstPtr> __param_descriptions__;
    CameraTransformConfig __max__;
    CameraTransformConfig __min__;
    CameraTransformConfig __default__;
    dynamic_reconfigure::ConfigDescription __description_message__;
    static const CameraTransformConfigStatics *get_instance()
    {
      // Split this off in a separate function because I know that
      // instance will get initialized the first time get_instance is
      // called, and I am guaranteeing that get_instance gets called at
      // most once.
      static CameraTransformConfigStatics instance;
      return &instance;
    }
  };

  inline const dynamic_reconfigure::ConfigDescription &CameraTransformConfig::__getDescriptionMessage__() 
  {
    return __get_statics__()->__description_message__;
  }

  inline const CameraTransformConfig &CameraTransformConfig::__getDefault__()
  {
    return __get_statics__()->__default__;
  }
  
  inline const CameraTransformConfig &CameraTransformConfig::__getMax__()
  {
    return __get_statics__()->__max__;
  }
  
  inline const CameraTransformConfig &CameraTransformConfig::__getMin__()
  {
    return __get_statics__()->__min__;
  }
  
  inline const std::vector<CameraTransformConfig::AbstractParamDescriptionConstPtr> &CameraTransformConfig::__getParamDescriptions__()
  {
    return __get_statics__()->__param_descriptions__;
  }

  inline const CameraTransformConfigStatics *CameraTransformConfig::__get_statics__()
  {
    const static CameraTransformConfigStatics *statics;
  
    if (statics) // Common case
      return statics;

    boost::mutex::scoped_lock lock(dynamic_reconfigure::__init_mutex__);

    if (statics) // In case we lost a race.
      return statics;

    statics = CameraTransformConfigStatics::get_instance();
    
    return statics;
  }


}

#endif // __CAMERATRANSFORMRECONFIGURATOR_H__
