/* Auto-generated by genmsg_cpp for file /tmp/buildd/ros-electric-art-vehicle-0.4.3/debian/ros-electric-art-vehicle/opt/ros/electric/stacks/art_vehicle/art_msgs/msg/CarDrive.msg */
#ifndef ART_MSGS_MESSAGE_CARDRIVE_H
#define ART_MSGS_MESSAGE_CARDRIVE_H
#include <string>
#include <vector>
#include <map>
#include <ostream>
#include "ros/serialization.h"
#include "ros/builtin_message_traits.h"
#include "ros/message_operations.h"
#include "ros/time.h"

#include "ros/macros.h"

#include "ros/assert.h"

#include "art_msgs/Gear.h"
#include "art_msgs/PilotBehavior.h"

namespace art_msgs
{
template <class ContainerAllocator>
struct CarDrive_ {
  typedef CarDrive_<ContainerAllocator> Type;

  CarDrive_()
  : speed(0.0)
  , acceleration(0.0)
  , jerk(0.0)
  , steering_angle(0.0)
  , gear()
  , behavior()
  {
  }

  CarDrive_(const ContainerAllocator& _alloc)
  : speed(0.0)
  , acceleration(0.0)
  , jerk(0.0)
  , steering_angle(0.0)
  , gear(_alloc)
  , behavior(_alloc)
  {
  }

  typedef float _speed_type;
  float speed;

  typedef float _acceleration_type;
  float acceleration;

  typedef float _jerk_type;
  float jerk;

  typedef float _steering_angle_type;
  float steering_angle;

  typedef  ::art_msgs::Gear_<ContainerAllocator>  _gear_type;
   ::art_msgs::Gear_<ContainerAllocator>  gear;

  typedef  ::art_msgs::PilotBehavior_<ContainerAllocator>  _behavior_type;
   ::art_msgs::PilotBehavior_<ContainerAllocator>  behavior;


private:
  static const char* __s_getDataType_() { return "art_msgs/CarDrive"; }
public:
  ROS_DEPRECATED static const std::string __s_getDataType() { return __s_getDataType_(); }

  ROS_DEPRECATED const std::string __getDataType() const { return __s_getDataType_(); }

private:
  static const char* __s_getMD5Sum_() { return "977b12f7daeec4c2a2276732baf95662"; }
public:
  ROS_DEPRECATED static const std::string __s_getMD5Sum() { return __s_getMD5Sum_(); }

  ROS_DEPRECATED const std::string __getMD5Sum() const { return __s_getMD5Sum_(); }

private:
  static const char* __s_getMessageDefinition_() { return "# Driving command for a car-like vehicle using Ackermann steering.\n\
# $Id: CarDrive.msg 1539 2011-05-09 04:09:20Z jack.oquin $\n\
\n\
# Drive at requested speed, acceleration and jerk (the 1st, 2nd and\n\
# 3rd derivatives of position). All are non-negative scalars. \n\
#\n\
# Speed is defined as the scalar magnitude of the velocity\n\
# vector. Direction (forwards or backwards) is determined by the gear.\n\
#\n\
# Zero acceleration means change speed as quickly as\n\
# possible. Positive acceleration may include deceleration as needed\n\
# to match the desired speed. It represents a desired rate and also a\n\
# limit not to exceed.\n\
#\n\
# Zero jerk means change acceleration as quickly as possible. Positive\n\
# jerk describes the desired rate of acceleration change in both\n\
# directions (positive and negative).\n\
#\n\
float32 speed                   # magnitude of velocity vector (m/s)\n\
float32 acceleration            # desired acceleration (m/s^2)\n\
float32 jerk                    # desired jerk (m/s^3)\n\
\n\
# Assumes Ackermann (front-wheel) steering. This angle is the average\n\
# yaw of the two front wheels in the vehicle frame of reference\n\
# (positive left), ignoring their slightly differing angles as if it\n\
# were a tricycle. This is *not* the angle of the steering wheel\n\
# inside the passenger compartment.\n\
#\n\
float32 steering_angle          # steering angle (radians)\n\
\n\
Gear gear                       # requested gear (no change if Naught)\n\
PilotBehavior behavior          # requested pilot behavior\n\
\n\
================================================================================\n\
MSG: art_msgs/Gear\n\
# ART vehicle transmission gear numbers\n\
#\n\
# Used by several different messages.\n\
\n\
# $Id: Gear.msg 1539 2011-05-09 04:09:20Z jack.oquin $\n\
\n\
# Gear numbers. \n\
#\n\
# Naught means: reset all Shifter relays; no change of CarDrive gear.\n\
uint8 Naught = 0\n\
uint8 Park = 1\n\
uint8 Reverse = 2\n\
uint8 Neutral = 3\n\
uint8 Drive = 4\n\
uint8 N_gears = 5\n\
\n\
uint8 value		# requested or reported gear number\n\
\n\
================================================================================\n\
MSG: art_msgs/PilotBehavior\n\
# ART autonomous vehicle pilot node behaviors.\n\
#\n\
# Normally, the pilot node does Run, continually sending commands to\n\
# the servo device actuators and monitoring their state.  With Pause,\n\
# the pilot becomes passive, allowing a learning algorithm or human\n\
# controller direct access to those devices.  In the Off state,\n\
# various devices are shut down: the transmission in Park, the brake\n\
# released, the throttle at idle.  The engine is not turned off, but\n\
# it could be.\n\
\n\
# $Id: PilotBehavior.msg 1539 2011-05-09 04:09:20Z jack.oquin $\n\
\n\
# Behavior value\n\
uint8 value\n\
\n\
# Behavior numbers:\n\
uint8 Run = 0                   # normal driving\n\
uint8 Pause = 1                 # stop issuing servo commands\n\
uint8 Off = 2                   # turn off devices\n\
uint8 N_behaviors = 3\n\
\n\
"; }
public:
  ROS_DEPRECATED static const std::string __s_getMessageDefinition() { return __s_getMessageDefinition_(); }

  ROS_DEPRECATED const std::string __getMessageDefinition() const { return __s_getMessageDefinition_(); }

  ROS_DEPRECATED virtual uint8_t *serialize(uint8_t *write_ptr, uint32_t seq) const
  {
    ros::serialization::OStream stream(write_ptr, 1000000000);
    ros::serialization::serialize(stream, speed);
    ros::serialization::serialize(stream, acceleration);
    ros::serialization::serialize(stream, jerk);
    ros::serialization::serialize(stream, steering_angle);
    ros::serialization::serialize(stream, gear);
    ros::serialization::serialize(stream, behavior);
    return stream.getData();
  }

  ROS_DEPRECATED virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    ros::serialization::IStream stream(read_ptr, 1000000000);
    ros::serialization::deserialize(stream, speed);
    ros::serialization::deserialize(stream, acceleration);
    ros::serialization::deserialize(stream, jerk);
    ros::serialization::deserialize(stream, steering_angle);
    ros::serialization::deserialize(stream, gear);
    ros::serialization::deserialize(stream, behavior);
    return stream.getData();
  }

  ROS_DEPRECATED virtual uint32_t serializationLength() const
  {
    uint32_t size = 0;
    size += ros::serialization::serializationLength(speed);
    size += ros::serialization::serializationLength(acceleration);
    size += ros::serialization::serializationLength(jerk);
    size += ros::serialization::serializationLength(steering_angle);
    size += ros::serialization::serializationLength(gear);
    size += ros::serialization::serializationLength(behavior);
    return size;
  }

  typedef boost::shared_ptr< ::art_msgs::CarDrive_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::art_msgs::CarDrive_<ContainerAllocator>  const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;
}; // struct CarDrive
typedef  ::art_msgs::CarDrive_<std::allocator<void> > CarDrive;

typedef boost::shared_ptr< ::art_msgs::CarDrive> CarDrivePtr;
typedef boost::shared_ptr< ::art_msgs::CarDrive const> CarDriveConstPtr;


template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const  ::art_msgs::CarDrive_<ContainerAllocator> & v)
{
  ros::message_operations::Printer< ::art_msgs::CarDrive_<ContainerAllocator> >::stream(s, "", v);
  return s;}

} // namespace art_msgs

namespace ros
{
namespace message_traits
{
template<class ContainerAllocator> struct IsMessage< ::art_msgs::CarDrive_<ContainerAllocator> > : public TrueType {};
template<class ContainerAllocator> struct IsMessage< ::art_msgs::CarDrive_<ContainerAllocator>  const> : public TrueType {};
template<class ContainerAllocator>
struct MD5Sum< ::art_msgs::CarDrive_<ContainerAllocator> > {
  static const char* value() 
  {
    return "977b12f7daeec4c2a2276732baf95662";
  }

  static const char* value(const  ::art_msgs::CarDrive_<ContainerAllocator> &) { return value(); } 
  static const uint64_t static_value1 = 0x977b12f7daeec4c2ULL;
  static const uint64_t static_value2 = 0xa2276732baf95662ULL;
};

template<class ContainerAllocator>
struct DataType< ::art_msgs::CarDrive_<ContainerAllocator> > {
  static const char* value() 
  {
    return "art_msgs/CarDrive";
  }

  static const char* value(const  ::art_msgs::CarDrive_<ContainerAllocator> &) { return value(); } 
};

template<class ContainerAllocator>
struct Definition< ::art_msgs::CarDrive_<ContainerAllocator> > {
  static const char* value() 
  {
    return "# Driving command for a car-like vehicle using Ackermann steering.\n\
# $Id: CarDrive.msg 1539 2011-05-09 04:09:20Z jack.oquin $\n\
\n\
# Drive at requested speed, acceleration and jerk (the 1st, 2nd and\n\
# 3rd derivatives of position). All are non-negative scalars. \n\
#\n\
# Speed is defined as the scalar magnitude of the velocity\n\
# vector. Direction (forwards or backwards) is determined by the gear.\n\
#\n\
# Zero acceleration means change speed as quickly as\n\
# possible. Positive acceleration may include deceleration as needed\n\
# to match the desired speed. It represents a desired rate and also a\n\
# limit not to exceed.\n\
#\n\
# Zero jerk means change acceleration as quickly as possible. Positive\n\
# jerk describes the desired rate of acceleration change in both\n\
# directions (positive and negative).\n\
#\n\
float32 speed                   # magnitude of velocity vector (m/s)\n\
float32 acceleration            # desired acceleration (m/s^2)\n\
float32 jerk                    # desired jerk (m/s^3)\n\
\n\
# Assumes Ackermann (front-wheel) steering. This angle is the average\n\
# yaw of the two front wheels in the vehicle frame of reference\n\
# (positive left), ignoring their slightly differing angles as if it\n\
# were a tricycle. This is *not* the angle of the steering wheel\n\
# inside the passenger compartment.\n\
#\n\
float32 steering_angle          # steering angle (radians)\n\
\n\
Gear gear                       # requested gear (no change if Naught)\n\
PilotBehavior behavior          # requested pilot behavior\n\
\n\
================================================================================\n\
MSG: art_msgs/Gear\n\
# ART vehicle transmission gear numbers\n\
#\n\
# Used by several different messages.\n\
\n\
# $Id: Gear.msg 1539 2011-05-09 04:09:20Z jack.oquin $\n\
\n\
# Gear numbers. \n\
#\n\
# Naught means: reset all Shifter relays; no change of CarDrive gear.\n\
uint8 Naught = 0\n\
uint8 Park = 1\n\
uint8 Reverse = 2\n\
uint8 Neutral = 3\n\
uint8 Drive = 4\n\
uint8 N_gears = 5\n\
\n\
uint8 value		# requested or reported gear number\n\
\n\
================================================================================\n\
MSG: art_msgs/PilotBehavior\n\
# ART autonomous vehicle pilot node behaviors.\n\
#\n\
# Normally, the pilot node does Run, continually sending commands to\n\
# the servo device actuators and monitoring their state.  With Pause,\n\
# the pilot becomes passive, allowing a learning algorithm or human\n\
# controller direct access to those devices.  In the Off state,\n\
# various devices are shut down: the transmission in Park, the brake\n\
# released, the throttle at idle.  The engine is not turned off, but\n\
# it could be.\n\
\n\
# $Id: PilotBehavior.msg 1539 2011-05-09 04:09:20Z jack.oquin $\n\
\n\
# Behavior value\n\
uint8 value\n\
\n\
# Behavior numbers:\n\
uint8 Run = 0                   # normal driving\n\
uint8 Pause = 1                 # stop issuing servo commands\n\
uint8 Off = 2                   # turn off devices\n\
uint8 N_behaviors = 3\n\
\n\
";
  }

  static const char* value(const  ::art_msgs::CarDrive_<ContainerAllocator> &) { return value(); } 
};

template<class ContainerAllocator> struct IsFixedSize< ::art_msgs::CarDrive_<ContainerAllocator> > : public TrueType {};
} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

template<class ContainerAllocator> struct Serializer< ::art_msgs::CarDrive_<ContainerAllocator> >
{
  template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
  {
    stream.next(m.speed);
    stream.next(m.acceleration);
    stream.next(m.jerk);
    stream.next(m.steering_angle);
    stream.next(m.gear);
    stream.next(m.behavior);
  }

  ROS_DECLARE_ALLINONE_SERIALIZER;
}; // struct CarDrive_
} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::art_msgs::CarDrive_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const  ::art_msgs::CarDrive_<ContainerAllocator> & v) 
  {
    s << indent << "speed: ";
    Printer<float>::stream(s, indent + "  ", v.speed);
    s << indent << "acceleration: ";
    Printer<float>::stream(s, indent + "  ", v.acceleration);
    s << indent << "jerk: ";
    Printer<float>::stream(s, indent + "  ", v.jerk);
    s << indent << "steering_angle: ";
    Printer<float>::stream(s, indent + "  ", v.steering_angle);
    s << indent << "gear: ";
s << std::endl;
    Printer< ::art_msgs::Gear_<ContainerAllocator> >::stream(s, indent + "  ", v.gear);
    s << indent << "behavior: ";
s << std::endl;
    Printer< ::art_msgs::PilotBehavior_<ContainerAllocator> >::stream(s, indent + "  ", v.behavior);
  }
};


} // namespace message_operations
} // namespace ros

#endif // ART_MSGS_MESSAGE_CARDRIVE_H

