"""autogenerated by genmsg_py from NavigatorCommand.msg. Do not edit."""
import roslib.message
import struct

import geometry_msgs.msg
import art_msgs.msg
import std_msgs.msg

class NavigatorCommand(roslib.message.Message):
  _md5sum = "415e5ee8b2ed1c9329a949ed123760f3"
  _type = "art_msgs/NavigatorCommand"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """# navigator command message
# $Id: NavigatorCommand.msg 615 2010-09-24 16:07:50Z jack.oquin $

Header header
Order  order

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: art_msgs/Order
# commander order for the navigator
# $Id: Order.msg 615 2010-09-24 16:07:50Z jack.oquin $

uint32 N_WAYPTS = 5     		# number of way-points in order
uint32 N_CHKPTS = 2             	# number of checkpoints in order

Behavior behavior			# requested behavior
art_msgs/WayPoint[5] waypt       	# way-point array
art_msgs/WayPoint[2] chkpt       	# next two goal checkpoints
float32 min_speed			# in meters/sec
float32 max_speed
int32 replan_num
int32 next_uturn         		# Uturn between [1] and [2]

================================================================================
MSG: art_msgs/Behavior
# ART Navigator behaviors (lower numbers have higher priority)
# $Id: Behavior.msg 996 2011-02-27 16:07:34Z jack.oquin $

# enumerated behavior values
int16 Abort       = 0
int16 Quit        = 1
int16 Pause       = 2
int16 Run         = 3
int16 Suspend     = 4
int16 Initialize  = 5
int16 Go          = 6
int16 NONE        = 7
int16 N_behaviors = 8

int16 value

================================================================================
MSG: art_msgs/WayPoint
# Way-point attributes
# $Id: WayPoint.msg 614 2010-09-24 15:08:46Z jack.oquin $

float64 latitude			# latitude in degrees
float64 longitude			# longitude in degrees
geometry_msgs/Point32 mapxy		# MapXY position
MapID id				# way-point ID
uint16 index    			# parser index of waypoint

# way-point flags
bool is_entry                           # lane or zone exit point
bool is_exit				# lane or zone entry point
bool is_goal				# this is a goal checkpoint
bool is_lane_change			# change lanes after here
bool is_spot				# parking spot
bool is_stop				# stop line here
bool is_perimeter			# zone perimeter point
int32 checkpoint_id			# checkpoint ID or zero
float32 lane_width

================================================================================
MSG: geometry_msgs/Point32
# This contains the position of a point in free space(with 32 bits of precision).
# It is recommeded to use Point wherever possible instead of Point32.  
# 
# This recommendation is to promote interoperability.  
#
# This message is designed to take up less space when sending
# lots of points at once, as in the case of a PointCloud.  

float32 x
float32 y
float32 z
================================================================================
MSG: art_msgs/MapID
# Road map identifier for segments, lanes and way-points.
# $Id: MapID.msg 614 2010-09-24 15:08:46Z jack.oquin $

uint16 NULL_ID = 65535

uint16 seg      # segment ID
uint16 lane     # lane ID
uint16 pt       # way-point ID

"""
  __slots__ = ['header','order']
  _slot_types = ['Header','art_msgs/Order']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.
    
    The available fields are:
       header,order
    
    @param args: complete set of field values, in .msg order
    @param kwds: use keyword arguments corresponding to message field names
    to set specific fields. 
    """
    if args or kwds:
      super(NavigatorCommand, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg._Header.Header()
      if self.order is None:
        self.order = art_msgs.msg.Order()
    else:
      self.header = std_msgs.msg._Header.Header()
      self.order = art_msgs.msg.Order()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    @param buff: buffer
    @type  buff: StringIO
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      buff.write(_struct_h.pack(self.order.behavior.value))
      for val1 in self.order.waypt:
        _x = val1
        buff.write(_struct_2d.pack(_x.latitude, _x.longitude))
        _v1 = val1.mapxy
        _x = _v1
        buff.write(_struct_3f.pack(_x.x, _x.y, _x.z))
        _v2 = val1.id
        _x = _v2
        buff.write(_struct_3H.pack(_x.seg, _x.lane, _x.pt))
        _x = val1
        buff.write(_struct_H7Bif.pack(_x.index, _x.is_entry, _x.is_exit, _x.is_goal, _x.is_lane_change, _x.is_spot, _x.is_stop, _x.is_perimeter, _x.checkpoint_id, _x.lane_width))
      for val1 in self.order.chkpt:
        _x = val1
        buff.write(_struct_2d.pack(_x.latitude, _x.longitude))
        _v3 = val1.mapxy
        _x = _v3
        buff.write(_struct_3f.pack(_x.x, _x.y, _x.z))
        _v4 = val1.id
        _x = _v4
        buff.write(_struct_3H.pack(_x.seg, _x.lane, _x.pt))
        _x = val1
        buff.write(_struct_H7Bif.pack(_x.index, _x.is_entry, _x.is_exit, _x.is_goal, _x.is_lane_change, _x.is_spot, _x.is_stop, _x.is_perimeter, _x.checkpoint_id, _x.lane_width))
      _x = self
      buff.write(_struct_2f2i.pack(_x.order.min_speed, _x.order.max_speed, _x.order.replan_num, _x.order.next_uturn))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    @param str: byte array of serialized message
    @type  str: str
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg._Header.Header()
      if self.order is None:
        self.order = art_msgs.msg.Order()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.header.frame_id = str[start:end]
      start = end
      end += 2
      (self.order.behavior.value,) = _struct_h.unpack(str[start:end])
      self.order.waypt = []
      for i in range(0, 5):
        val1 = art_msgs.msg.WayPoint()
        _x = val1
        start = end
        end += 16
        (_x.latitude, _x.longitude,) = _struct_2d.unpack(str[start:end])
        _v5 = val1.mapxy
        _x = _v5
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _struct_3f.unpack(str[start:end])
        _v6 = val1.id
        _x = _v6
        start = end
        end += 6
        (_x.seg, _x.lane, _x.pt,) = _struct_3H.unpack(str[start:end])
        _x = val1
        start = end
        end += 17
        (_x.index, _x.is_entry, _x.is_exit, _x.is_goal, _x.is_lane_change, _x.is_spot, _x.is_stop, _x.is_perimeter, _x.checkpoint_id, _x.lane_width,) = _struct_H7Bif.unpack(str[start:end])
        val1.is_entry = bool(val1.is_entry)
        val1.is_exit = bool(val1.is_exit)
        val1.is_goal = bool(val1.is_goal)
        val1.is_lane_change = bool(val1.is_lane_change)
        val1.is_spot = bool(val1.is_spot)
        val1.is_stop = bool(val1.is_stop)
        val1.is_perimeter = bool(val1.is_perimeter)
        self.order.waypt.append(val1)
      self.order.chkpt = []
      for i in range(0, 2):
        val1 = art_msgs.msg.WayPoint()
        _x = val1
        start = end
        end += 16
        (_x.latitude, _x.longitude,) = _struct_2d.unpack(str[start:end])
        _v7 = val1.mapxy
        _x = _v7
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _struct_3f.unpack(str[start:end])
        _v8 = val1.id
        _x = _v8
        start = end
        end += 6
        (_x.seg, _x.lane, _x.pt,) = _struct_3H.unpack(str[start:end])
        _x = val1
        start = end
        end += 17
        (_x.index, _x.is_entry, _x.is_exit, _x.is_goal, _x.is_lane_change, _x.is_spot, _x.is_stop, _x.is_perimeter, _x.checkpoint_id, _x.lane_width,) = _struct_H7Bif.unpack(str[start:end])
        val1.is_entry = bool(val1.is_entry)
        val1.is_exit = bool(val1.is_exit)
        val1.is_goal = bool(val1.is_goal)
        val1.is_lane_change = bool(val1.is_lane_change)
        val1.is_spot = bool(val1.is_spot)
        val1.is_stop = bool(val1.is_stop)
        val1.is_perimeter = bool(val1.is_perimeter)
        self.order.chkpt.append(val1)
      _x = self
      start = end
      end += 16
      (_x.order.min_speed, _x.order.max_speed, _x.order.replan_num, _x.order.next_uturn,) = _struct_2f2i.unpack(str[start:end])
      return self
    except struct.error as e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    @param buff: buffer
    @type  buff: StringIO
    @param numpy: numpy python module
    @type  numpy module
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      buff.write(_struct_h.pack(self.order.behavior.value))
      for val1 in self.order.waypt:
        _x = val1
        buff.write(_struct_2d.pack(_x.latitude, _x.longitude))
        _v9 = val1.mapxy
        _x = _v9
        buff.write(_struct_3f.pack(_x.x, _x.y, _x.z))
        _v10 = val1.id
        _x = _v10
        buff.write(_struct_3H.pack(_x.seg, _x.lane, _x.pt))
        _x = val1
        buff.write(_struct_H7Bif.pack(_x.index, _x.is_entry, _x.is_exit, _x.is_goal, _x.is_lane_change, _x.is_spot, _x.is_stop, _x.is_perimeter, _x.checkpoint_id, _x.lane_width))
      for val1 in self.order.chkpt:
        _x = val1
        buff.write(_struct_2d.pack(_x.latitude, _x.longitude))
        _v11 = val1.mapxy
        _x = _v11
        buff.write(_struct_3f.pack(_x.x, _x.y, _x.z))
        _v12 = val1.id
        _x = _v12
        buff.write(_struct_3H.pack(_x.seg, _x.lane, _x.pt))
        _x = val1
        buff.write(_struct_H7Bif.pack(_x.index, _x.is_entry, _x.is_exit, _x.is_goal, _x.is_lane_change, _x.is_spot, _x.is_stop, _x.is_perimeter, _x.checkpoint_id, _x.lane_width))
      _x = self
      buff.write(_struct_2f2i.pack(_x.order.min_speed, _x.order.max_speed, _x.order.replan_num, _x.order.next_uturn))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    @param str: byte array of serialized message
    @type  str: str
    @param numpy: numpy python module
    @type  numpy: module
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg._Header.Header()
      if self.order is None:
        self.order = art_msgs.msg.Order()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.header.frame_id = str[start:end]
      start = end
      end += 2
      (self.order.behavior.value,) = _struct_h.unpack(str[start:end])
      self.order.waypt = []
      for i in range(0, 5):
        val1 = art_msgs.msg.WayPoint()
        _x = val1
        start = end
        end += 16
        (_x.latitude, _x.longitude,) = _struct_2d.unpack(str[start:end])
        _v13 = val1.mapxy
        _x = _v13
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _struct_3f.unpack(str[start:end])
        _v14 = val1.id
        _x = _v14
        start = end
        end += 6
        (_x.seg, _x.lane, _x.pt,) = _struct_3H.unpack(str[start:end])
        _x = val1
        start = end
        end += 17
        (_x.index, _x.is_entry, _x.is_exit, _x.is_goal, _x.is_lane_change, _x.is_spot, _x.is_stop, _x.is_perimeter, _x.checkpoint_id, _x.lane_width,) = _struct_H7Bif.unpack(str[start:end])
        val1.is_entry = bool(val1.is_entry)
        val1.is_exit = bool(val1.is_exit)
        val1.is_goal = bool(val1.is_goal)
        val1.is_lane_change = bool(val1.is_lane_change)
        val1.is_spot = bool(val1.is_spot)
        val1.is_stop = bool(val1.is_stop)
        val1.is_perimeter = bool(val1.is_perimeter)
        self.order.waypt.append(val1)
      self.order.chkpt = []
      for i in range(0, 2):
        val1 = art_msgs.msg.WayPoint()
        _x = val1
        start = end
        end += 16
        (_x.latitude, _x.longitude,) = _struct_2d.unpack(str[start:end])
        _v15 = val1.mapxy
        _x = _v15
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _struct_3f.unpack(str[start:end])
        _v16 = val1.id
        _x = _v16
        start = end
        end += 6
        (_x.seg, _x.lane, _x.pt,) = _struct_3H.unpack(str[start:end])
        _x = val1
        start = end
        end += 17
        (_x.index, _x.is_entry, _x.is_exit, _x.is_goal, _x.is_lane_change, _x.is_spot, _x.is_stop, _x.is_perimeter, _x.checkpoint_id, _x.lane_width,) = _struct_H7Bif.unpack(str[start:end])
        val1.is_entry = bool(val1.is_entry)
        val1.is_exit = bool(val1.is_exit)
        val1.is_goal = bool(val1.is_goal)
        val1.is_lane_change = bool(val1.is_lane_change)
        val1.is_spot = bool(val1.is_spot)
        val1.is_stop = bool(val1.is_stop)
        val1.is_perimeter = bool(val1.is_perimeter)
        self.order.chkpt.append(val1)
      _x = self
      start = end
      end += 16
      (_x.order.min_speed, _x.order.max_speed, _x.order.replan_num, _x.order.next_uturn,) = _struct_2f2i.unpack(str[start:end])
      return self
    except struct.error as e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

_struct_I = roslib.message.struct_I
_struct_h = struct.Struct("<h")
_struct_2f2i = struct.Struct("<2f2i")
_struct_H7Bif = struct.Struct("<H7Bif")
_struct_2d = struct.Struct("<2d")
_struct_3I = struct.Struct("<3I")
_struct_3H = struct.Struct("<3H")
_struct_3f = struct.Struct("<3f")
