"""autogenerated by genmsg_py from ObservationArray.msg. Do not edit."""
import roslib.message
import struct

import art_msgs.msg
import std_msgs.msg

class ObservationArray(roslib.message.Message):
  _md5sum = "b5eeab09687abc64c329078cb1e9065a"
  _type = "art_msgs/ObservationArray"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """# Observations from a set of observers
# $Id: ObservationArray.msg 1628 2011-08-09 21:51:35Z jack.oquin $

Header header
Observation[] obs                       # vector of observations

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: art_msgs/Observation
# result returned from a single observer
# $Id: Observation.msg 1614 2011-08-06 21:02:59Z jack.oquin $

# possible observer ID values
int32 Nearest_forward    = 0		# current or closest lane
int32 Nearest_backward   = 1                  
int32 Adjacent_left	 = 2		# adjacent left or right lane
int32 Adjacent_right	 = 3
int32 All_left		 = 4		# all left or right lanes
int32 All_right 	 = 5
int32 Merge_into_nearest = 6            # merge into nearest lane on diff seg
int32 Merge_across_all   = 7            # merge across all lanes on diff seg
int32 Intersection	 = 8		# stop sign intersection precedence
int32 N_Observers        = 9

int32  oid                      # observer ID
string name                     # observer name

bool applicable                 # true if obseravation is applicable
bool clear                      # true if clear to go

# optional time and distance to nearest obstacle
# (only reported by some observers)
float32 time
float32 distance
float32 velocity
int32 nobjects  		# number of objects

"""
  __slots__ = ['header','obs']
  _slot_types = ['Header','art_msgs/Observation[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.
    
    The available fields are:
       header,obs
    
    @param args: complete set of field values, in .msg order
    @param kwds: use keyword arguments corresponding to message field names
    to set specific fields. 
    """
    if args or kwds:
      super(ObservationArray, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg._Header.Header()
      if self.obs is None:
        self.obs = []
    else:
      self.header = std_msgs.msg._Header.Header()
      self.obs = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    @param buff: buffer
    @type  buff: StringIO
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.obs)
      buff.write(_struct_I.pack(length))
      for val1 in self.obs:
        buff.write(_struct_i.pack(val1.oid))
        _x = val1.name
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_struct_2B3fi.pack(_x.applicable, _x.clear, _x.time, _x.distance, _x.velocity, _x.nobjects))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    @param str: byte array of serialized message
    @type  str: str
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg._Header.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.obs = []
      for i in range(0, length):
        val1 = art_msgs.msg.Observation()
        start = end
        end += 4
        (val1.oid,) = _struct_i.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.name = str[start:end]
        _x = val1
        start = end
        end += 18
        (_x.applicable, _x.clear, _x.time, _x.distance, _x.velocity, _x.nobjects,) = _struct_2B3fi.unpack(str[start:end])
        val1.applicable = bool(val1.applicable)
        val1.clear = bool(val1.clear)
        self.obs.append(val1)
      return self
    except struct.error as e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    @param buff: buffer
    @type  buff: StringIO
    @param numpy: numpy python module
    @type  numpy module
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.obs)
      buff.write(_struct_I.pack(length))
      for val1 in self.obs:
        buff.write(_struct_i.pack(val1.oid))
        _x = val1.name
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_struct_2B3fi.pack(_x.applicable, _x.clear, _x.time, _x.distance, _x.velocity, _x.nobjects))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    @param str: byte array of serialized message
    @type  str: str
    @param numpy: numpy python module
    @type  numpy: module
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg._Header.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.obs = []
      for i in range(0, length):
        val1 = art_msgs.msg.Observation()
        start = end
        end += 4
        (val1.oid,) = _struct_i.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.name = str[start:end]
        _x = val1
        start = end
        end += 18
        (_x.applicable, _x.clear, _x.time, _x.distance, _x.velocity, _x.nobjects,) = _struct_2B3fi.unpack(str[start:end])
        val1.applicable = bool(val1.applicable)
        val1.clear = bool(val1.clear)
        self.obs.append(val1)
      return self
    except struct.error as e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

_struct_I = roslib.message.struct_I
_struct_i = struct.Struct("<i")
_struct_3I = struct.Struct("<3I")
_struct_2B3fi = struct.Struct("<2B3fi")
