"""autogenerated by genmsg_py from ThrottleState.msg. Do not edit."""
import roslib.message
import struct

import std_msgs.msg

class ThrottleState(roslib.message.Message):
  _md5sum = "5b1c64434e6ebe49625631607b188cd5"
  _type = "art_msgs/ThrottleState"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """# ART throttle controller state message

# $Id: ThrottleState.msg 644 2010-09-28 03:19:07Z jack.oquin $

Header  header

float32 position                # fractional position [0, 1]
float32 rpms                    # engine speed (rev/min)
uint8   estop                   # emergency stop indicator

# optional extra diagnostic information:
float32 pwm                     # Pulse Width Modulation value
float32 dstate                  # PID derivative state
float32 istate                  # PID integral state

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

"""
  __slots__ = ['header','position','rpms','estop','pwm','dstate','istate']
  _slot_types = ['Header','float32','float32','uint8','float32','float32','float32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.
    
    The available fields are:
       header,position,rpms,estop,pwm,dstate,istate
    
    @param args: complete set of field values, in .msg order
    @param kwds: use keyword arguments corresponding to message field names
    to set specific fields. 
    """
    if args or kwds:
      super(ThrottleState, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg._Header.Header()
      if self.position is None:
        self.position = 0.
      if self.rpms is None:
        self.rpms = 0.
      if self.estop is None:
        self.estop = 0
      if self.pwm is None:
        self.pwm = 0.
      if self.dstate is None:
        self.dstate = 0.
      if self.istate is None:
        self.istate = 0.
    else:
      self.header = std_msgs.msg._Header.Header()
      self.position = 0.
      self.rpms = 0.
      self.estop = 0
      self.pwm = 0.
      self.dstate = 0.
      self.istate = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    @param buff: buffer
    @type  buff: StringIO
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2fB3f.pack(_x.position, _x.rpms, _x.estop, _x.pwm, _x.dstate, _x.istate))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    @param str: byte array of serialized message
    @type  str: str
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg._Header.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 21
      (_x.position, _x.rpms, _x.estop, _x.pwm, _x.dstate, _x.istate,) = _struct_2fB3f.unpack(str[start:end])
      return self
    except struct.error as e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    @param buff: buffer
    @type  buff: StringIO
    @param numpy: numpy python module
    @type  numpy module
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2fB3f.pack(_x.position, _x.rpms, _x.estop, _x.pwm, _x.dstate, _x.istate))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    @param str: byte array of serialized message
    @type  str: str
    @param numpy: numpy python module
    @type  numpy: module
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg._Header.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 21
      (_x.position, _x.rpms, _x.estop, _x.pwm, _x.dstate, _x.istate,) = _struct_2fB3f.unpack(str[start:end])
      return self
    except struct.error as e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

_struct_I = roslib.message.struct_I
_struct_3I = struct.Struct("<3I")
_struct_2fB3f = struct.Struct("<2fB3f")
